import React from 'react'
import { compose } from 'recompose'

import {
  ContextualBox,
  AuthorReply,
  withFilePreview,
  withFileDownload,
} from '../'

const ResponseToRevisionRequest = ({
  fragment,
  authorReply,
  toggle,
  expanded,
  downloadFile,
  previewFile,
  ...rest
}) => (
  <ContextualBox
    expanded={expanded}
    label="Response to Revision Request"
    mb={2}
    toggle={toggle}
    {...rest}
  >
    <AuthorReply
      authorReply={authorReply}
      fragment={fragment}
      onDownload={downloadFile}
      onPreview={previewFile}
    />
  </ContextualBox>
)

export default compose(withFilePreview, withFileDownload)(
  ResponseToRevisionRequest,
)
